### CACTUSHOME 
### Path completo con el lugar donde esta el programa el directorio Cactus
### Se lee de

source("Cactushome.R");

PlotPriop <- function( al=alfa, be=beta,
		main="Gamma prior distribution for p", xlab="p", ...)
{
	plot( function(x) { dbeta( x, al, be); },
		xlim=c(0,1),
		main=main, xlab=xlab, ylab="Density", ... );
}


GammaPriorkmsd <- function( mean=meank, sd=sdk, pl=TRUE,
	main="Gamma Prior for k", xlab="k", ...)
{
	if (pl)
		ks <- max(1, floor(mean-4*sd)):floor(mean+4*sd)
	else
		ks <- 1:MAXK;


	probs <- dgamma( ks, (mean/sd)^2, scale=1/(mean/(sd^2)));
	probs <- probs/sum(probs);

	if (pl)
		plot( ks, (probs), main=main, ylab="Probability", xlab=xlab, pch=20, ...)
	else
		matrix(append( ks, probs), ncol=2);
}



BinomialPriorX1  <- function( k=nX1, p=pX1, save=FALSE,
		 main="Binomial prior distribution for X1", xlab="k", ...)
{
	sd <- sqrt(k*p*(1-p));
	mean <- k*p;
	ks <- max(0, floor(mean-4*sd)):floor(mean+4*sd);

	probs <- dbinom( ks, size=k, prob=p);
	probs <- probs/sum(probs);

	plot( ks, probs, main=main, xlab=xlab, ...);
}



Run <- function(project)
{
	
	fnam <- paste( project, "/", project, ".R", sep="");
	cat("Leyendo los parametros del proyecto:", fnam, "\n");
	source(fnam); 

	fnam <- paste( project, "/", project, ".Priork.png", sep="");
	cat("Escribiendo la dist. inicial para k:", fnam, "\n");
	png(fnam);
	GammaPriorkmsd();
	dev.off();
	write( t(GammaPriorkmsd(pl=FALSE)), paste( project, ".Priork", sep=""), ncolumns=2);

	fnam <- paste( project, "/", project, ".PriorX1.png", sep="");
	cat("Escribiendo la dist. inicial para X1:", fnam, "\n");
	png(fnam);
	BinomialPriorX1();
	dev.off();
	
	fnam <- paste( project, "/", project, ".Priorp.png", sep="");
	cat("Escribiendo la dist. inicial para p:", fnam, "\n");
	png(fnam);
	PlotPriop();
	dev.off()


	fnam <- paste( project, "/", project, ".pars", sep="");
	cat("Escribiendo el archivo de parametros para ABaCA:", fnam, "\n");

	F <- file( fnam, "w");

	cat( "MAXK: ", MAXK, "\n", sep="", file=F);

	cat( "MAXM: ", MAXM, "\n", sep="", file=F);
	cat( "LRUN: ", LRUN, "\n", sep="", file=F);
	cat( "ITER: ", ITER, "\n", sep="", file=F);
	cat( "PART: ", PART, "\n", sep="", file=F);
	cat( "alfa: ", alfa, "\n", sep="", file=F);
 	cat( "beta: ", beta, "\n", sep="", file=F);
	cat( "d: ", d, "\n", sep="", file=F);

	cat( "\nStop: ", Stop, "\n", sep="", file=F);
	cat( "Maxjump: ", Maxjump, "\n", sep="", file=F);
	cat( "a: ", a, "\n", sep="", file=F);
	cat( "b: ", b, "\n", sep="", file=F);
	cat( "dec: ", dec, "\n", sep="", file=F);
	cat( "maxj: ", maxj, "\n", sep="", file=F);

	close(F);

	command <- paste( CACTUSHOME, "bin/ABaCA", " ",
		project, "/", project, " ", project, "/", project, " ", graphtype, sep="");
	cat("LLamando a ABaCA:", command, "\n");
	system(command);

	cat("\n\nVea las graficas (*.png) en el directorio",  project, "\n\n");

}

