#define ABACAHOME "/Users/jac/sync/gente/Miguel/Cactus"
//La linea de arriba la escribe el instalador
// Principal Program.

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "Functions.h"
#include "Data.hh"
#include "ABaCA.hh"
#include "Stop.hh"


#define GRAPHPATH "graphics"

#ifdef UNIX_AND_R

#include "interp.h"
#define GRAPHPATH "graphics"

int dographics( char *nam, int type, int level)
{
	if (type == -1)
		return -1; //no graphics

	printf("Making plots, calling R...\n");

	interpreterdebugg(1);        //--slave
	interpreteropen("R --vanilla --slave");

	if (level == 4) //stoping times
	{
        	interpretersend("Base <- \"%s\";", nam);
        	interpretersend("grphtype <- %d;", type);

        	interpretersend("source(\"%s/%s/ratios.R\");",
        		ABACAHOME, GRAPHPATH);

        	interpreterclose();

        	return 1;
	}


        interpretersend("Base <- \"%s\";", nam);
        interpretersend("level <- %d;", level);
        interpretersend("grphtype <- %d;", type);


        interpretersend("source(\"%s/%s/plots.R\");", ABACAHOME, GRAPHPATH);

        interpreterclose();

        return 1;
}

#endif
#ifndef UNIX_AND_R
int dographics( char *nam, int type, int level)
{
	printf("No graphics output.\n");

        return 1;
}
#endif

main(int argc, char *argv[])
{
	int grptype=0;	//0 eps, 1 png

        if (argc < 2)
        {
        	printf("Uso: ABaCA datos parametros [eps/png/none]\n");
                exit(0);
        }

	//	Este if se activa si el usuario solicita ayuda desde el
	//	teclado.
	if(argv[1][0] == '-')
	{
        	printf("Uso: ABaCA datos parametros [eps/png/none]\n");
                exit(0);
	}

	if (argc == 4)
	{
		if (strcmp( argv[3], "none") == 0)
			grptype=-1;
		if (strcmp( argv[3], "eps") == 0)
			grptype=0;
		if (strcmp( argv[3], "png") == 0)
			grptype=1;
	}


	Seed((int) time(NULL));

	Data D( argv[1], argv[2]);  //se abre un objeto para guardar todos los datos

        if (D.Maxperiod() == D.Minperiod()) //periodos iguales
        {
        	if (D.Fut() == 0) //sin prediccion.
                {
                	Analytic C(&D);
                        C.Go();
                        dographics( argv[1], grptype, 1); //graficar hist. para k y p
                }
                else  //con prediccion.
                {
                	EqualPred C(&D);
                        C.Go();
                        dographics( argv[1], grptype, 3);//graficar de las simulaciones
                }
        }
        else //periodos desiguales.
        {
        	UnEqual C(&D);
                C.Go();
                if (D.Fut() == 0)
                	dographics( argv[1], grptype, 2);//graficar de las sim pero solo k y p
                else
                	dographics( argv[1], grptype, 3);//graficar de las simulaciones
        }

        if (D.Stop())
        {
		printf("\nTiempo de paro.\nCreando tabla de conteos...\n");
		char fnam[255];
		sprintf( fnam, "%s.sim", argv[1]);
		Tab Tabla( &D, fnam);

		Tabla.OutTab( 	D.A(), D.B(), D.Dec(),
				D.Fut(), D.Maxj(), ' ', argv[1]);


     		dographics( argv[1], grptype, 4);//graficar la matrix O_t(s)
	}
        
        printf("\nEs totototototoooodo amigos!\n\n");
        
        	
	return 1;
}

