#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Data.hh"

#ifndef BCUMM_H
#define BCUMM_H

//To compile it in UNIX with the R interphase for graphics output
#define UNIX_AND_R

#define CP 0.9999 //cortamos las dist. cuando se ha acumulado 100*CP% de prob.




class Cumm
{
	protected:
        	int u;		
		Data *D;
	public:
		Cumm(Data *Da)
                {
                	D = Da;
                        u = D->U();
               }

		void Go() { /*nada, clase base.*/ }
};


//periodos iguales, sin prediccion.  Go() esta implementada en Analytic.cpp
class Analytic : public Cumm  
{
	private:
        	double vpB, vpBpA;
                double *p;
                double Probk(int k);
                double Densp(double pr);
	public:
		Analytic(Data *Da) : Cumm(Da)
                {
                	vpB = (double) D->V() + D->Be();
                        vpBpA = vpB + D->Al();
                        p = new double[D->Maxk()];
                        if (p == NULL)
                        {
                        	printf("Insuficiente memoria, Analytic::p!!!\n");
                                exit(0);
                        }
                }
		void Go();
};	

class MCMC : public Cumm
{
	protected:
        	int k;
                double p, *ax;
		int *ax1, *ax2;
        	virtual void Pass() { /*nada, clase base*/ }
        	void DoSample();  //Estos estan en MCMC.cpp
                void MakePosts();
        public:
        	MCMC(Data *Da);
};

//periodos iguales, con prediccion.  Go() esta implementada en ??
class EqualPred : public MCMC  
{
	private:
        	double np1;
                int SimX(int d); //Estos esta en Equal.cpp
                int Simk();  
        	void Pass();
	public:
		EqualPred(Data *Da) : MCMC(Da)
                {
                        np1 = (double) (D->N() + 1);
                }
		void Go()
                {
                	printf("\nPrediccion, periodos iguales.\n");
			printf("1   \n");
                        DoSample();
        		MakePosts();
                }
};	

//periodos desiguales, con o sin prediccion.  Go() esta implementada en ??
class UnEqual : public MCMC  
{
	private:
        	double vpB;
                int SimX(int d); //Estos estan en Unequal.cpp
                int Simk();  
         	void Pass();
	public:
		UnEqual(Data *Da) : MCMC(Da)
                {
                	vpB = (double) D->V() + D->Be();
                }
		void Go()
                {
                	printf("\nPeriodos desiguales.\n");
			DoSample();
        		MakePosts();
                }
};	


#endif











	
