// Implementation of Analitica class

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "ABaCA.hh"
#include "Data.hh"
#include "Functions.h"




void Analytic::Go()
{

	FILE *F;
	char nam[LEN];
	
        printf("\nSe utilizara el metodo analitico\n");
		
	sprintf( nam, "%s.Postk", D->Fnam());
	
	if( (F = fopen ( nam, "w")) == NULL)
	{	
		printf("No se pudo abrir archivo %s para la posterior de k\n",
                	nam);
		exit(0);
	}
        
        printf("Calculando la posterior para k, u= %d, v= %d\n",
        	D->U(), D->V());
	double S = 0.0;
	for(int k = D->U(); k < D->Maxk(); k++)
	{
		p[k] = Probk(k);
		S += p[k];
	}
	
        printf("Escribiendo la posterior de k en %s (Maxk=%d)\n", nam, D->Maxk()); 	/*Con este ciclo normalizamos las probabilidades de k
            agregamos primero unos ceros antes de u*/
	double cum=0.0; //100*CP% de la probabilidad
        for (int b=D->U()-3; b<D->U(); b++)
        	fprintf( F, "%3d\t%g\n", b, 0.0);
	for (int k = D->U(); (k < D->Maxk()) && ((cum += p[k-1]) < CP); k++)
	{
		p[k] /= S;
		fprintf( F, "%3d\t%g\n", k, p[k]);
	}
	fclose(F);



	//Calculamos la densidad para p.
	sprintf( nam, "%s.Postp", D->Fnam());
	
	if( (F = fopen (nam, "w")) == NULL)
	{	
		printf("No se pudo abrir archivo %s para la posterior de p\n",
                	nam);
		exit(0);
	}

        printf("Escribiendo la posterior de p en %s\n", nam); 
	double jmp = D->Part();
        
        double denspr;
        cum=0.0;
        for (double pr=0.0;
             (pr<1.0) && ((cum += denspr*jmp) < CP);
             pr += jmp)
             	fprintf( F, "%g\t%g\n", pr, (denspr = Densp(pr)));	
       	
        /*for (double pr=D->Lowp(); pr <= D->Upp(); pr += jmp)
        	fprintf( F, "%g\t%g\n", pr, Densp(pr));*/
	
	fclose(F);

        
}

//Funcion de probabilidad para k, sin normalizar
double Analytic::Probk(int k)
{
	double x;

	x = 	Ifac(k, u) +
        	log(D->Priork(k)) +
                gammlm((double) D->N()*k + vpB) -
                gammlm((double) (D->N()*k + u) + vpBpA);
	
	return (exp(x));
}


//densidad para p, asumiendo que en p[] se encuentra la funcion de densidad de k.
double Analytic::Densp(double pr)
{
        double S = 0.0;        
	for (int k=u; k <= D->Maxk(); k++)
	{
		S += 	p[k] *
                	Betadens( (double) u + D->Al(),
                        	  (double) (D->N()*k) + vpB, 
                                  pr);
	}
        
        return S;
}

