// Principal Program.
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#include "Functions.h"
#include "ABaCA.hh"

int EqualPred::Simk()
{
	double S=0.0;
        for (int k1=u; k1<D->Maxk(); k1++)
        {
        	ax[k1] =
                  exp(Ifac(k1,u) + D->N()*k1*log(1.0-p) + log(D->Priork(k1)));
                S += ax[k1];
        }
        
        
        double cm=0.0, r=Un01();
        k=u;
        while ((cm += ax[k]/S) <= r)
        	k++;
        
        return k;
}


#define EqualPredPx(x) ( Combins((int) r,(int) x)*pow(p,x)*pow(tmp,r-x)/cns )
int EqualPred::SimX(int d)
{
	double r = (double) (k - (D->U() - D->GetX(d))); 
        
        //n=m+D_d
        //i=m+d, (1-p)^(n+1-i) = (1-p)^(D_d+1-d) 
        double tmp = pow(1.0-p, (double) (D->Fut()-d+1)); 
        double cns = pow(p + tmp, r); //Constante de normalizacion.
        
        double cm=0.0, ra=Un01();
        double x=0.0;
        cm += EqualPredPx(x);
        while (cm <= ra)
        {
        	cm += EqualPredPx(x);
        	x++;
        } 
        
        if (x>r) printf("Error: x=%f y r=%f\n", x,r);

        return D->SetX((int) x, d); 
}

//Aqui hacemos una iteracion del MCMC
void EqualPred::Pass()
{
	
        u = D->U();

        //Simulamos la k
        Simk();
        
        //Simulamos la p.
        p = Betasim( (double) u + D->Al(), (double) D->N()*k + D->V() + D->Be());

	//Simulamos las futuras
	for (int d=1; d<=D->Fut(); d++)
        	SimX(d);
        

}

