#include <gsl_rng.h>
#include <gsl_randist.h>
#include <gsl_specfunc.h>
#include <gsl_sf_gamma.h>
#include <time.h>

#include "ABaCA.hh"

/*Random and miselaneous utility functions*/

#ifndef FUNC_H
#define FUNC_H


#define PI 3.141592653589793

#define min( x, y) ( ((x) < (y)) ? (x) : (y) )
#define max( x, y) ( ((x) > (y)) ? (x) : (y) )

#define sqr(x) ( (x) * (x) )

/*Interphase with gsl*/

/*Available random number generators from gsl
gsl_rng_cmrg, gsl_rng_minstd, gsl_rng_mrg, gsl_rng_mt19937,
       gsl_rng_r250, gsl_rng_ran0, gsl_rng_ran1, gsl_rng_ran2,
       gsl_rng_ran3, gsl_rng_rand, gsl_rng_rand48,
       gsl_rng_random_bsd, gsl_rng_random_glibc2,
       gsl_rng_random_libc5, gsl_rng_randu, gsl_rng_ranf,
       gsl_rng_ranlux, gsl_rng_ranlux389, gsl_rng_ranmar,
       gsl_rng_slatec, gsl_rng_taus, gsl_rng_tds, gsl_rng_tt800,
       gsl_rng_uni, gsl_rng_uni32, gsl_rng_vax, gsl_rng_zuf

       see http://sourceware.cygnus.com/gsl/ref/gsl-ref_5.html*/


#define GENERATOR gsl_rng_taus


void Seed(unsigned long int s);
unsigned long int rt_seed();

//Basic random number generator and inlined function.
double Un01();


double Fac(int t);
double Ifac(int n, int x);
double Combins(int n, int x);


double Nordens(double m, double std, double x);
double Norsim(double m, double std);


double gammlm(double x);
double Gamma(double x);
double Gammadens(double x);
double Gammasim(double a, double b);


double Beta(double v, double w);
double Betadens(double v,double w, double q);
double Betasim(double a, double b); /*solo para a y b enteros*/

double BnmPrb(double p, unsigned int n, unsigned int x);
int Bnmsim(double p, unsigned int n);


/*double *Dirichlet(int k, double *al, double *pi);
double *normalise(int n, double *pi);*/


#endif
