#include <stdio.h>
#include <math.h>
#include <string.h>
#include "Stop.hh"


Tab::Tab( Data *D, char *fnam)
{

	FILE *G;
        if ((G = fopen( fnam, "r")) == NULL)
        {
        	printf("No se pudo abrir el archivo %s para lectura.\n\n",
                	fnam);
		//exit(0);
        }
        
        strncpy(ln, fnam, 255);
        n=D->N(); //n
        u=D->uu(); //S(0)
        T=D->Fut(); //T

        mxj=D->Maxjump(); //h_max

	C = new count [(T+1)*mxj]; 
        
        for (int i=0; i<T*mxj; i++)
        {
        	C[i].M = 0;
                C[i].U = -1.0;
                C[i].O = -1.0;
                for (int jmp=0; jmp<MXJMP; jmp++)
                	C[i].Mj[jmp] = 0;
        }

        int a, b, x, ax;
        double p;
        N=0;
        do
        {
        	fscanf( G, " %d %lf", &ax, &p); //k and p, not used

        	a=0;
        	b=0;  	
        	for (int t=0; t<T; t++)
                {
                	fscanf( G, " %d", &x);
                	b += x;
        		AddM( t, a);
                        AddMj( t, a, b-a);
                        a=b;
                }
                N++;
                if (N % 10000 == 0)
                	printf("i: %d\n", N);

                fscanf( G, " %d\n", &ax); //S(T), not used.
                fgetc(G);
        } while (!feof(G));
}


double Tab::GetR(int t, int j)
{
	if (t == T)
        	return f( T, j);
	if (GetM( t, j) == 0)
        	return 0.0;
        
        double Mtj= (double) GetM( t, j), Sum=0.0;

        for (int s=0; (s<MXJMP)&&(s+j<mxj); s++)
        	Sum += (GetMj( t, j, s)/Mtj)*GetU( t+1, j+s);
        
        return Sum;
} 

void Tab::DoTab(double aa, double bb)
{
	double R, C;
        
        a = aa;
        b = bb;
        
        for (int t=T; t>=0; t--)
        	for (int j=0; j<mxj; j++)
                {
                	if ((R = GetR( t, j)) == 0.0)
                        {
                        	SetU( t, j, 0.0);
				Setu0( t, j, 0.0);
                                SetO( t, j, 0.0);
                        }
                        else
                        {
				Setu0( t, j, R);
                        	C = f( t, j);
                        	if (R > C)
                        		SetU( t, j, R);
                        	else
                        		SetU( t, j, C);
                                
                                SetO( t, j, R/C);
                        }
                }
} 

void Tab::OutTab(double aa, double bb,
		int dec, int maxt, int maxj, char sep,
		char *proy)
{
	printf("Creando tabla de utilidades, a= %f, b= %f\n\n", aa, bb);
	DoTab( aa, bb);

	char fnam[255];
	FILE *out;
	sprintf( fnam, "%s.O", proy);
	if ((out=fopen( fnam, "w"))==NULL)
 		printf("No se pudo abrir el archivo %s\n",fnam);

	int tmax;
        tmax = (T <= maxt) ? T-1 : maxt;
        if (out == stdout)
        	fprintf( out, "a= %f, b= %f: %s\n", a, b, ln);
        fprintf( out, " %c%c ", 's', sep);
        for (int t=0; t<=tmax; t++)
        	fprintf( out, "%*d%c ", dec+2, t, sep);
        fprintf( out, "\n");
        for (int j=(mxj <= maxj) ? mxj-1 : maxj; j>=0; j--)
        {
        	fprintf( out, "%2d%c ", u+j, sep);
        	for (int t=0; t<=tmax-1; t++)
         		fprintf( out, "%*.*f%c ", dec+2, dec,
         			GetO( t, j), sep);
                fprintf( out, "%*.*f%c ", dec+2, dec,
                	GetO( tmax, j), ' ');
                fprintf( out, "\n");
        }
        fprintf( out, "\n");
	fclose(out);

        printf("Razn: %*.*f\n", dec+2, dec, GetO( 0, 0));
        if (GetO( 0, 0) < 1.0)
        	printf("\nParar. Utildad: %f\n", GetU(0,0));
        else
        	printf("\nSeguir. Utildad: %f\n", GetU(0,0));



//Tabla para u0 y u1

	sprintf( fnam, "%s.u", proy);
	if ((out=fopen( fnam, "w"))==NULL)
 		printf("No se pudo abrir el archivo %s\n",fnam);

        tmax = (T <= maxt) ? T-1 : maxt;
        if (out == stdout)
        	fprintf( out, "a= %f, b= %f: %s\n", a, b, ln);
        fprintf( out, " %c%c ", 's', sep);
        for (int t=0; t<=tmax; t++)
        	fprintf( out, "%*d%c ", dec+4, t, sep);
        fprintf( out, "\n");
        for (int j=(mxj <= maxj) ? mxj-1 : maxj; j>=0; j--)
        {
        	fprintf( out, "%2d%c ", u+j, sep);
        	for (int t=0; t<=tmax-1; t++)
         		fprintf( out, "%*.*f%c ", dec+4, dec,
         			Getu0( t, j), sep);
                fprintf( out, "%*.*f%c ", dec+4, dec,
                	Getu0( tmax, j), ' ');
                fprintf( out, "\n");
        }
        fprintf( out, "\n\n\n\n");

//tabla para u1

        tmax = (T <= maxt) ? T-1 : maxt;
        if (out == stdout)
        	fprintf( out, "a= %f, b= %f: %s\n", a, b, ln);
        fprintf( out, " %c%c ", 's', sep);
        for (int t=0; t<=tmax; t++)
        	fprintf( out, "%*d%c ", dec+4, t, sep);
        fprintf( out, "\n");
        for (int j=(mxj <= maxj) ? mxj-1 : maxj; j>=0; j--)
        {
        	fprintf( out, "%2d%c ", u+j, sep);
        	for (int t=0; t<=tmax-1; t++)
         		fprintf( out, "%*.*f%c ", dec+4, dec,
         			Getu1( t, j), sep);
                fprintf( out, "%*.*f%c ", dec+4, dec,
                	Getu1( tmax, j), ' ');
                fprintf( out, "\n");
        }
        fprintf( out, "\n");
	fclose(out);


}

















