// Principal Program.
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#include "Functions.h"
#include "ABaCA.hh"


//Esta es la misma que para periodos iguales
int UnEqual::Simk()
{
	double S=0.0;
        for (int k1=u; k1<D->Maxk(); k1++)
        {
        	ax[k1] =
                  exp(Ifac(k1,u) + D->N()*k1*log(1.0-p) + log(D->Priork(k1)));
                S += ax[k1];
        }
        
        
        double cm=0.0, r=Un01();
        k=u;
        while ((cm += ax[k]/S) < r)
        	k++;
        
        return k;
}


#define UnEqualPx(x) ( Combins((int) r,(int) x)*pow(p1,x)*pow(tmp,r-x)/cns )
int UnEqual::SimX(int d)
{
	double r = (double) (k - (D->U() - D->GetX(d))); 
        
        //l=m+d => j_l = GetJ(d), h_l=D->GetH(d).
        //(1-p)^(n-j_{l-1}) = (1-p)^(D->N()-D->GetJ(d-1)) 
        double tmp = pow(1.0-p, (double) (D->N() - D->GetJ(d-1)));
        double p1  = 1.0-pow(1.0-p, D->GetH(d)); 
        double cns = pow(p1 + tmp, r); //Constante de normalizacion.
        
        double cm=0.0, ra=Un01();
        double x=0.0;
        while ((cm += UnEqualPx(x)) < ra)
        	x++;
        
        if (x>r) printf("Error: x=%f y r=%f\n", x,r);

        return D->SetX((int) x, d); 
}

//Prototipo para el simulador de p, contenido en simp.c
void UnESimp(double *rtp, int *cnt, double alpha, double b, int m,
	const int *x, const int *hh); // a = alpha, b = nk + v + beta 
int cnt;
double rtp;
//Aqui hacemos una iteracion del MCMC
void UnEqual::Pass()
{
	u = D->U();

        //Simulamos la k
        Simk();
        
        
        //Simulamos la p.
	UnESimp( &rtp, &cnt,
        	(double) D->Al(), (double) (D->N()*k + D->V()) + D->Be(),
                D->M()+D->Fut(),
                D->ArrX()+1, D->ArrH()+1);
        
        p=rtp;
        
	//Simulamos las futuras
	for (int d=1; d<=D->Fut(); d++)
        	SimX(d);

}

