### Program in R to perform all the graphics required
### ABaCA sets the following options:
###Base <- "project_name";
###level <- 1;  ##1 for analytic, 2 simulation, 3 simulation with prediction.
###grphtype <- 0; ##0 for eps, 1 for png.




setgraphics <- function( type, nam)
{
	if (type == 0)
	{
		postscript( nam,
			horizontal=FALSE, onefile=FALSE,
			height=7, width=7, pointsize=12);
	}
	if (type == 1)
	{
		png(filename= nam,
			width=480, height=480, pointsize=12);
	}
}
	




if (grphtype == 0)
	grext <- ".eps";
if (grphtype == 1)
	grext <- ".png";


fnam <- paste( Base, ".dat", sep="");
jumps <- read.table( fnam, header=FALSE);
setgraphics( grphtype, paste( Base, ".cum", grext, sep=""));
plot( append(c(0), jumps[,1]),  append(c(0), cumsum(jumps[,2])),
	xlab="Effort", ylab="Number of species",
	main="Accumulation curve.");
dev.off();


fnam <- paste( Base, ".Postk", sep="");
postk <- read.table( fnam, header=FALSE);
setgraphics( grphtype, paste( fnam, grext, sep=""));
plot(postk, bty="n",
     xlab="k", ylab="Probability",
     main="Posterior distribution for k.");
dev.off();

if (level == 1)
{
	fnam <- paste( Base, ".Postp", sep="");
	postp <- read.table( fnam, header=FALSE);
	setgraphics( grphtype, paste( fnam, grext, sep=""));
	plot(postp, type="l", bty="n",
     		xlab="p", ylab="Density",
     		main="Posterior distribution for p.");
	dev.off();
}

if (level >= 2)
{
	fnam <- paste( Base, ".sim", sep="");
	sim <- read.table( fnam, header=FALSE);
	setgraphics( grphtype, paste( Base, ".Postpsim", grext, sep=""));
	plot(density(sim[,2]), bty="n",
     		xlab="Probability", main="Posterior distribution for p.");
	dev.off();
}

if (level == 3)
{
	fnam <- paste( Base, ".PostS", sep="");
	postS <- read.table( fnam, header=FALSE);
	setgraphics( grphtype, paste( fnam, grext, sep=""));
	plot(postS, bty="n",
     		xlab="Number of species", ylab="Probability",
     	main="Posterior for new discoveries in 5 future units of effort.");
	dev.off();
}




