### Program in R to create a figure with the O_t(s) matrix for stopping times
### ABaCA sets the following options:
###Base <- "project_name";
###grphtype <- 0; ##0 for eps, 1 for png.

setgraphics <- function( type, nam, T, h)
{
	h <- ifelse( h>2, h-2, 0);
	T <- ifelse( T>2, T-2, 0);

	if (type == 0)
	{
		postscript( nam,
			horizontal=FALSE, onefile=FALSE,
			paper="special", height=3+0.2*h, width=3+0.9*T,
			pointsize=12);
	}
	if (type == 1)
	{
		png(filename= nam,
			height=180+15*h, width=180+54*T, pointsize=12);
	}
}
	

if (grphtype == 0)
	grext <- ".eps";
if (grphtype == 1)
	grext <- ".png";

tab <- read.table( paste( Base, ".O", sep=""), header=TRUE);

T <- dim(tab)[2]-2;
h <- dim(tab)[1];
s1 <- tab[h,1];
s2 <- tab[1,1];
u <- tab[h,1];

setgraphics( grphtype, paste( Base, ".O", grext, sep=""), T, s2-s1);

image( 0:T, s1:s2, t(as.matrix(tab[h:(h-(s2-s1)),2:(T+2)])), axes=FALSE,
	col=c("#FF0000", "#00FF00"), breaks=c(0.0000001,0.9999999,2E300),
	xlab="Additional units of effort",
	ylab="Total number of species");

axis( 1, 0:T, paste(0:T));
axis( 2, s1:s2, paste(s1:s2));

abline(h=((s1:(s2+1))-0.5));
abline(v=((0:(T+1))-0.5));

for (j in h:1)
	for (t in 0:T)
	{
		if (tab[j,t+2] != 0.0)
		{
			text( t, tab[j,1], paste(tab[j,t+2]));
		}
	}


dev.off();
